# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ChromeUXReport.V1.Model.CollectionPeriod do
  @moduledoc """
  The collection period is a date range which includes the `first` and `last` day.

  ## Attributes

  *   `firstDate` (*type:* `GoogleApi.ChromeUXReport.V1.Model.Date.t`, *default:* `nil`) - The first day in the collection period, inclusive.
  *   `lastDate` (*type:* `GoogleApi.ChromeUXReport.V1.Model.Date.t`, *default:* `nil`) - The last day in the collection period, inclusive.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :firstDate => GoogleApi.ChromeUXReport.V1.Model.Date.t() | nil,
          :lastDate => GoogleApi.ChromeUXReport.V1.Model.Date.t() | nil
        }

  field(:firstDate, as: GoogleApi.ChromeUXReport.V1.Model.Date)
  field(:lastDate, as: GoogleApi.ChromeUXReport.V1.Model.Date)
end

defimpl Poison.Decoder, for: GoogleApi.ChromeUXReport.V1.Model.CollectionPeriod do
  def decode(value, options) do
    GoogleApi.ChromeUXReport.V1.Model.CollectionPeriod.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ChromeUXReport.V1.Model.CollectionPeriod do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
