# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ChromeUXReport.V1.Model.FractionTimeseries do
  @moduledoc """
  For enum metrics, provides fraction timeseries which add up to approximately 1.0 per entry (k-th element into the repeated fractions field for any k <= len) across fraction_timeseries.

  ## Attributes

  *   `fractions` (*type:* `list(float())`, *default:* `nil`) - Values between 0.0 and 1.0 (inclusive) and NaN.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :fractions => list(float()) | nil
        }

  field(:fractions, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.ChromeUXReport.V1.Model.FractionTimeseries do
  def decode(value, options) do
    GoogleApi.ChromeUXReport.V1.Model.FractionTimeseries.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ChromeUXReport.V1.Model.FractionTimeseries do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
