# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ChromeUXReport.V1.Model.TimeseriesBin do
  @moduledoc """
  A bin is a discrete portion of data spanning from start to end, or if no end is given, then from start to +inf. A bin's start and end values are given in the value type of the metric it represents. For example, "first contentful paint" is measured in milliseconds and exposed as ints, therefore its metric bins will use int32s for its start and end types. However, "cumulative layout shift" is measured in unitless decimals and is exposed as a decimal encoded as a string, therefore its metric bins will use strings for its value type.

  ## Attributes

  *   `densities` (*type:* `list(float())`, *default:* `nil`) - The proportion of users that experienced this bin's value for the given metric in a given collection period; the index for each of these entries corresponds to an entry in the CollectionPeriods field in the HistoryRecord message, which describes when the density was observed in the field. Thus, the length of this list of densities is equal to the length of the CollectionPeriods field in the HistoryRecord message.
  *   `end` (*type:* `any()`, *default:* `nil`) - End is the end of the data bin. If end is not populated, then the bin has no end and is valid from start to +inf.
  *   `start` (*type:* `any()`, *default:* `nil`) - Start is the beginning of the data bin.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :densities => list(float()) | nil,
          :end => any() | nil,
          :start => any() | nil
        }

  field(:densities, type: :list)
  field(:end)
  field(:start)
end

defimpl Poison.Decoder, for: GoogleApi.ChromeUXReport.V1.Model.TimeseriesBin do
  def decode(value, options) do
    GoogleApi.ChromeUXReport.V1.Model.TimeseriesBin.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ChromeUXReport.V1.Model.TimeseriesBin do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
